﻿$g_TempFolder = $env:TEMP
$g_WindowsVersion = [System.Environment]::OSVersion.Version
$ErrorActionPreference = "Stop"

$g_Major = $g_WindowsVersion.Major
$g_Minor = $g_WindowsVersion.Minor

Write-Output "Checking Windows version: $g_WindowsVersion"
if ($g_Major -eq 6 -and $g_Minor -eq 1)
{
    # Windows 7 / Windows Server 2008r2
}
elseif ($g_Major -eq 6 -and $g_Minor -eq 2)
{
    # Windows 8 / Windows Server 2012
}
elseif ($g_Major -eq 6 -and $g_Minor -eq 3)
{
    # Windows 8.1 Blue / Windows Server 2012r2
}
elseif ($g_Major -eq 10 -and $g_Minor -eq 0)
{
    # Windows 10 / Windows Server 2016
}
else
{
    Write-Error "Unsupported Windows version: $g_WindowsVersion"
    Exit 1
}

$g_PnputilArguments = "-i -a bin.${g_Major}.${g_Minor}\ena.inf"

Write-Output "Starting pnputil $g_PnputilArguments"
$g_SetupProcess = Start-Process -FilePath 'pnputil' -ArgumentList $g_PnputilArguments -PassThru -Wait

$g_SetupProcessRetval = $g_SetupProcess.ExitCode
Write-Output "Pnputil return value is $g_SetupProcessRetval"

if ($g_SetupProcessRetval -eq 259)
{
    Write-Output "Pnputil could return $g_SetupProcessRetval when the driver with the same version has been installed. Treat this as success"
    $g_SetupProcessRetval = 0
}

Write-Output "Done, return $g_SetupProcessRetval to the caller"

Exit $g_SetupProcessRetval
